<?php 

require "fct.php";	
list($event, $title, $logo, $style, $factions) = event();

	
if (isset($_POST["pwd"]) && (urldecode($_POST["pwd"]) == $ini["password"]) && isset($_POST["token"]) && ($_POST["token"] === $csrf_token)) {
		
		$_SESSION["loggedin"] = md5($csrf_token.$ini["password"]); // Einloggen hat geklappt
		
	} elseif (isset($_SESSION["loggedin"])) { // Änderungen übermitteln nur wenn eingeloggt
	
	if (isset($_POST["action"]) && ($_POST["action"] == "close") && isset($_POST["discussion"]) && is_numeric($_POST["discussion"]) && isset($_POST["event"]) && is_numeric($_POST["event"]) && isset($_POST["token"]) && ($_POST["token"] === $csrf_token)) {
		
		/* Redeliste schließen */
		 
		$discussion = $_POST["discussion"];
		$db->exec("UPDATE discussion SET closed = '1' WHERE event_id = $event AND discussion_id = $discussion AND closed = 0");
		$disc_status = "closed";
		
	} elseif (isset($_POST["action"]) && ($_POST["action"] == "open") && isset($_POST["discussion"]) && is_numeric($_POST["discussion"]) && isset($_POST["event"]) && is_numeric($_POST["event"]) && isset($_POST["token"]) && ($_POST["token"] === $csrf_token)) {
		
		/* Redeliste wieder öffnen */
		$discussion = $_POST["discussion"];
		$db->exec("UPDATE discussion SET closed = '0' WHERE event_id = $event AND discussion_id = $discussion AND closed = 1");
		$disc_status = "closed";
		
	} elseif (isset($_POST["neueliste"]) && isset($_POST["event"]) && is_numeric($_POST["event"]) && isset($_POST["discussion"]) && is_numeric($_POST["discussion"]) && isset($_POST["token"]) && ($_POST["token"] === $csrf_token)) {

		/* Neue Redeliste anlegen und zu ihr wechseln */

		$disc_title = trim(strip_tags(htmlspecialchars($_POST["neueliste"], ENT_QUOTES)));
		if (empty($disc_title)) { $disc_title = $_POST["discussion"] +1; }
		
		$db->exec("UPDATE discussion SET closed = '1' WHERE event_id = $event AND closed = 0");
		
		$db->exec("INSERT INTO discussion (
		   event_id, 
		   title, 
		   created,
		   closed
		   ) VALUES (
		   '".$event."', 
		   '".$disc_title."',
		   '".time()."',
		   '0'
		   )");
		   
		   $discussion = $db->lastInsertRowid();
		   
		   foreach ($factions AS $fackey => $facval) {
			   $db->exec("INSERT INTO timelog (
				discussion_id,
				faction_id, 
				last_update
				) VALUES (
				'" . $discussion . "', 
				'" . $fackey . "', 
				'" . time() . "'
				)");
		   }


	}
}


	list($discussion, $disc_title, $disc_status) = discussion();

	if (isset($_GET["t"]) && ($_GET["t"] == $csrf_token))  {
		
		if (isset($_GET["w"]) && is_numeric($_GET["w"]) && isset($_GET["sf"]) && is_numeric($_GET["sf"])) {
			// Person zu anderer Faction übertragen
				
				$person = $_GET["w"];
				$newfaction = $_GET["sf"] + 1;
				if (count($factions) < $newfaction) { $newfaction = 1; }
				
			$db->exec("UPDATE waiting SET faction_id = '" . $newfaction . "' WHERE waiting_id = $person AND discussion_id = $discussion AND status = 0");
			
		} elseif (isset($_GET["wf"]) && is_numeric($_GET["wf"]) && isset($_GET["a"]) && ($_GET["a"] == "s")) {
			// Unknown person speaks
			
			$wf = $_GET["wf"];
			
			// Wortmeldung eintragen
				$sql = "INSERT INTO waiting (
						discussion_id, person, organisation, faction_id, status, created, started) VALUES (
						$discussion, 'Anonym (" . $factions[$wf] . ")', '', ".$wf.", 1, '".time()."', '".time()."')";
				$db-> exec($sql);
			
					
		} elseif (isset($_GET["w"]) && is_numeric($_GET["w"]) && isset($_GET["a"]) && ($_GET["a"] == "s")) {
			// person speaks
			
			$person = $_GET["w"];
			$db->exec("UPDATE waiting SET status = '1', started = '" . time() . "' WHERE waiting_id = $person AND discussion_id = $discussion AND status = 0");
				

		} elseif (isset($_GET["w"]) && is_numeric($_GET["w"]) && isset($_GET["f"]) && is_numeric($_GET["f"]) && isset($_GET["a"]) && ($_GET["a"] == "e")) {
			// person ends speaking
			
			$person = $_GET["w"];
			$speaking_faction = $_GET["f"];
			
			
			$res = $db->querySingle("SELECT started
					FROM waiting
					WHERE waiting_id = $person AND discussion_id = $discussion AND status = 1");

			if (!is_null($res)) { // Nur wenn Sprecher*in noch aktiv (Konflikt bei doppelten Logins abfangen)

				$speaking_duration = time() - $res;
			
				unset($res);
					
				$db->exec("UPDATE waiting SET status = '2' WHERE waiting_id = $person AND discussion_id = $discussion AND status = 1");
				
				$res = $db->querySingle("SELECT duration
						FROM timelog
						WHERE discussion_id = $discussion
						AND faction_id = $speaking_faction 
						");
				// Gesamtzeit der Faction berechnen und aktualisieren
				$newduration = $res + $speaking_duration; 
				$db->exec("UPDATE timelog
						SET duration = '" . $newduration . "'
						WHERE discussion_id = $discussion
						AND faction_id = $speaking_faction"
						);
		
			}
			

		} elseif (isset($_GET["w"]) && is_numeric($_GET["w"]) && isset($_GET["a"]) && ($_GET["a"] == "x")) {
			// Abhaken waiting person
			
			$person = $_GET["w"];
			$db->exec("UPDATE waiting SET status = '3' WHERE waiting_id = $person AND discussion_id = $discussion AND status = 0");
		}
		
		
	}



	// Redeliste der Diskussion abrufen
			
			$res = $db->query("SELECT waiting_id, person, organisation, faction_id, status, created, started
				FROM waiting
				WHERE discussion_id = $discussion
				AND status < 2 
				ORDER BY created");
			while ($row = $res->fetchArray()) {
				
				if (!empty($row['organisation'])) { 
				
					$org_temp = '<br>'.$row['organisation'];
				
				} else { 
				
					$org_temp = '';
					
				}
				
				$group[$row['faction_id']][] = '<p><span title="Wortmeldung eingereicht um '.date('H:i', $row['created']).' Uhr"><b>' . 
					$row['person']. '</b>' . $org_temp . '</span>
					<br>
					<a class="btn" href="admin.php?w=' . $row['waiting_id'] . '&a=s&t=' . $csrf_token . '" title="Start Person spricht"><button>🗣</button></a> 
					<a class="btn" href="admin.php?w=' . $row['waiting_id'] . '&a=x&t=' . $csrf_token . '" title="Aus Liste entfernen"><button>✖</button></a> 
					<a class="btn" href="admin.php?w=' . $row['waiting_id'] . '&sf=' . $row['faction_id'] . '&t=' . $csrf_token . '" title="Gruppe wechseln"><button>⇄</button></a>
					<a class="btn" href="blocklist.php?w=' . $row['waiting_id'] . '&t=' . $csrf_token . '" title="Blockieren"><button>☠</button></a>
					</p>';
			
				if ($row["status"] == 1) { // Wenn jemand gerade spricht
			
					$active_speaker = 1;
					$speaking_person = $row["person"];
					$speaking_organisation = $row["organisation"];
					$speaking_faction = $row["faction_id"];
					$speaking_id = $row["waiting_id"];
					$speaking_started = $row["started"]; // Wird benutzt bei Startanzeige Stoppuhr
					
				}
			}


htmlheader();

?>
<body><?php
  
	  pageheader(basename(__FILE__, '.php'));
	  
	  if (!isset($_SESSION["loggedin"])) { // Nicht eingeloggt?
		  
		  loginform();
		  
	  } else { // Zeige Admin-Seite
	
		if (isset($active_speaker)) {
			
			$delay = time() - $speaking_started; // Berechnen wie viel Zeit schon vergangen ist, seitdem die Rede begann
			
			?><div class="overlay"><div class="overlay-first overlay-content">
				<p>Im Augenblick spricht<br>
				<b class="timer"><?= $speaking_person ?></b><?php
					if (!empty($speaking_organisation)) { echo '<br>'.$speaking_organisation; }
				?>
				</p>
			<p class="timer">🗣 <b><span id="timer"></span></b></p>
			<script>
				var sekunden;
				sekunden = <?= $delay ?>; // müsste meist 0 sein, aber delay beinhaltet, falls Seite nach Beginn der Rede verspätet aufgerufen wird.
				document.getElementById("timer").innerHTML = "0:00";
			
				var counter = setInterval(function(){
					
					sekunden++;
					var s = sekunden%60;
					var minuten = Math.floor(sekunden/60);
				
					document.getElementById("timer").innerHTML = ""+minuten+":"+(s>9?"":"0")+s+"";
				 }, 1000);
			
			</script><p>&nbsp;</p>
			<?php
				echo '<a class="btn" href="admin.php?w=' . $speaking_id . '&a=e&f= ' . $speaking_faction .'&t=' . $csrf_token . '" title="Zeiterfassung wird beendet">';
				?><button>Zeiterfassung beenden ✖</button></a> 
			<br><br>
			Direkt wechseln zu<br>
			<table id="redeliste">
				<tr><?php
					foreach ($factions AS $fackey => $facval) {
						echo '<th><a class="btn" href="admin.php?wf=' . $fackey . '&a=s&t=' . $csrf_token . '" title="Start Anonym('.$facval.') spricht"><button>'.$facval.'</button></a></th>';
					}
				?></tr>
			</table>
			
			
			
			</div></div>
			
			<?php
			
		
	}
		
	  ?><main>
	  
	  <h1>Redeliste #<?= $disc_title ?> <a class="btn" href="settings.php?d=<?= $discussion ?>&t=<?= $csrf_token ?>" title="Diese Redeliste verwalten"><button>💬</button></a></h1>
			<form enctype="application/x-www-form-urlencoded" method="post" name="open-close" action="admin.php">
				<input name="discussion" value="<?= $discussion ?>" id="discussion" type="hidden">
				<input name="event" value="<?= $event ?>" id="event" type="hidden">
				<input name="token" value="<?= $csrf_token ?>" id="token" type="hidden">
				<?php 
				if ($disc_status == "closed") {
					
					echo '<input name="action" value="open" id="action" type="hidden">
				<button type="submit">🔓 Wieder öffnen</button></h1>';
				
				} else {
					
				echo '<input name="action" value="close" id="action" type="hidden">
				<button type="submit">🔏 schließen</button></h1>';
				
				}
				?>
			</form>
	  <table id="redeliste">
	  <tr><?php
		foreach ($factions AS $fackey => $facval) {
			echo '<th>'.$facval.' <a class="btn" href="admin.php?wf=' . $fackey . '&a=s&t=' . $csrf_token . '" title="Start Person spricht"><button>🗣</button></a></th>';
		}
	  ?></tr>
	  <tr><?php
		foreach ($factions AS $fackey => $facval) {
		  
		  echo '<td>';
			if (array_key_exists($fackey, $group)) {
				foreach ($group[$fackey] AS $key => $val) {
					echo $val;
			}
		 } 
		 if ($disc_status == "closed") { echo "=== geschlossen ==="; }
		 echo '</td>';
	 }
		 ?></tr><?php 
	  	  
	  	  // Zeige Redeanteile
	  	  durbars();
	  	  ?>
	  </table>Stand: <?php echo date("H:i"); ?>  <a class="btn" href="admin.php" title="Aktualisieren"><button>↻</button></a>
	  
	  <p>&nbsp;</p>
	  
	  <form enctype="application/x-www-form-urlencoded" method="post" action="admin.php">
			Neue Redeliste #<input title="Namen vergeben oder automatische Nummerierung" name="neueliste" id="neueliste" value="" placeholder="<?= $discussion+1 ?>" class="form-control" type="text">
			<input name="event" id="event" value="<?= $event; ?>" type="hidden">
			<input name="discussion" value="<?= $discussion ?>" id="discussion" type="hidden">
			<input name="token" value="<?= $csrf_token ?>" id="token" type="hidden">
			<input name="submit" id="submit" value="anlegen &amp; wechseln" type="submit">
	  </form>
	  
	  <p>&nbsp;</p><p>&nbsp;</p>

	  </div>
	</main>
	
	
	<?php
} // Ende Admin-Seite

		pagefooter();
		
	?>	  
  </body>
</html><?php $db->close(); unset($db);
