<?php 

require "fct.php";	

list($event, $title, $logo, $style, $factions) = event();
list($discussion, $disc_title, $disc_status) = discussion();

//$db->exec("ALTER TABLE event ADD COLUMN prio INTEGER NOT NULL DEFAULT '0'");
	
// Formular Wortmeldung wurde übermittelt

if (isset($_POST["person"]) && isset($_POST["organisation"]) && isset($_POST["faction"]) && !empty(trim($_POST["person"])) && is_numeric($_POST["faction"]) && isset($_POST["token"]) && ($_POST["token"] === $csrf_token)) {
	
	$_SESSION["name"] = trim(strip_tags(htmlspecialchars($_POST["person"], ENT_QUOTES)));
	$_SESSION["organisation"] = trim(strip_tags(htmlspecialchars($_POST["organisation"], ENT_QUOTES)));
	$_SESSION["faction"] = $_POST["faction"];
		
	// Checken ob schon vorhanden
	
	if ($disc_status == "closed") {
		
		// Hinweis wenn Redeliste geschlossen ist
		$error = "Redeliste ist derzeit geschlossen.";
		
	} else {
	
		$sql = "SELECT COUNT(*) AS count
				FROM waiting
				WHERE discussion_id = $discussion
				AND person LIKE '".$_SESSION['name']."'
				AND organisation LIKE '".$_SESSION['organisation']."'
				AND status = 0";
		$res = $db->querySingle($sql);
		
		if ($res == 0) {	// falls Wortmeldung noch nicht vorhanden
				
			// Wortmeldung eintragen
			$sql = "INSERT INTO waiting (
					discussion_id, person, organisation, faction_id, status, session, created) VALUES (
					$discussion, '".$_SESSION['name']."', '".$_SESSION['organisation']."', ".$_SESSION['faction'].", 0, '".session_id()."', '".time()."')";
			$db-> exec($sql);
			

	} else {
		
		// Hinweis bei Wortmeldung schon vorhanden
		$error = "Wortmeldung ist bereits auf der Liste.";
			}	
	}
		
	
} elseif (!isset($_SESSION["name"])) { $_SESSION = array("name" => "", "organisation" => "", "faction" => ""); }


if (isset($_GET["t"]) && ($_GET["t"] == $csrf_token) && isset($_GET["w"]) && is_numeric($_GET["w"]) && isset($_GET["a"]) && ($_GET["a"] == "x")) {
			// delete waiting person
			
			$person = $_GET["w"];
			$db->exec("DELETE FROM waiting WHERE waiting_id = $person AND discussion_id = $discussion AND status = 0 AND session LIKE '".session_id()."'");
		}


// Redeliste der Diskussion abrufen
			
			$res = $db->query("SELECT *
				FROM waiting
				WHERE discussion_id = $discussion
				AND status = 0 
				ORDER BY created");
			while ($row = $res->fetchArray()) {
				
				if($row["session"] == session_id()) { $del_temp = ' <a class="btn" href="index.php?w=' . $row['waiting_id'] . '&a=x&t=' . $csrf_token . '" title="Meine Wortmeldung zurücknehmen"><button>✖</button></a>'; } else { $del_temp = ""; }
				
				$group[$row['faction_id']][] = '<p title="Wortmeldung eingereicht um '.date('H:i', $row['created']).' Uhr"><b>'.$row['person'].'</b>' .$del_temp .'<br>'.$row['organisation'].'</p>';
			}
			
			
	htmlheader();		
?>
  <body><?php
  
	  pageheader(basename(__FILE__, '.php'));
	
	  ?><main>
		  
	  <h1>Redeliste #<span style="text-transform: uppercase;"><?= $disc_title ?></span></h1>
	  <table id="redeliste">
	  <tr><?php
		foreach ($factions AS $facval) {
			echo '<th>'.$facval.'</th>';
		}
	  ?></tr>
	  <tr><?php
		foreach ($factions AS $fackey => $facval) {
		  
		  echo '<td class="redeliste-element">';
			if (array_key_exists($fackey, $group)) {
				foreach ($group[$fackey] AS $key => $val) {
					echo $val;
			}
		 } 
		 if ($disc_status == "closed") { echo "<p>=== geschlossen ===</p>"; }
		 
		 echo '<p>&nbsp;</p></td>';
	 }
		 ?></tr>
	  	 <?php 
	  	  
	  	  // Zeige Redeanteile
	  	  durbars();
	  	  ?>
	  </table>Stand: <?php echo date("H:i"); ?>  <a class="btn" href="index.php" title="Aktualisieren"><button>↻</button></a><p>&nbsp;</p>

<a name="wortmeldung"></a>
	  <div id="wortmeldung">
			<form role="form" enctype="application/x-www-form-urlencoded" method="post" action="">
				<h2>🙋 Wortmeldung einreichen</h2>
				<?php
				if (!empty($error)) { echo '<p style="color: red;">' . $error . '</p>'; }
				?>
				<input name="person" id="person" value="<?= $_SESSION['name'] ?>" placeholder="Name" type="text" maxlength="60" required><br>
				<input name="organisation" id="organisation" value="<?= $_SESSION['organisation'] ?>" placeholder="Organisation" maxlength="60" type="text"><br>
				
				<?php
				foreach ($factions AS $fackey => $facval) {
					echo '<label><input type="radio" name="faction" value="'.$fackey.'" ';
					if ($_SESSION["faction"]==$fackey) {echo 'checked="checked" ';} 
					echo 'required="required"><span style="font-size: 14pt;">'.$facval.'</span></label> &nbsp;';
				}
				?>

				&nbsp;&nbsp;&nbsp;<input name="submit" id="submit" value="Einreichen" class="btn" type="submit">
				<input name="discussion" value="<?= $discussion ?>" id="discussion" type="hidden">
				<input name="token" value="<?= $csrf_token ?>" id="token" type="hidden">
				
			</form>
	  </div><p>&nbsp;</p>
	</main>
	<?php
	
		pagefooter();
		
	?>	  
  </body>
</html><?php $db->close(); unset($db);
