<?php 

require "fct.php";	
list($event, $title, $logo, $style, $factions) = event();

htmlheader();

?><body><?php
  
	pageheader(basename(__FILE__, '.php'));
	
	?><main>
	  	  
	<h1>Statistik</h1>
	  
	<?php
	  
	$sql = "SELECT discussion_id, title, duration
			FROM discussion
				WHERE event_id = $event";
				
	$res = $db->query($sql);
	
	while ($row = $res->fetchArray()) {
			
		echo '<h2>Redeliste: #'.$row["title"].'</h2>';
		
		$discussion = $row['discussion_id'];
		$duration_full = 1;
			
		foreach ($factions AS $fackey => $facval) {
			
			$speakers[$discussion][$fackey] = $db->querySingle("SELECT COUNT(*) AS count			
				FROM waiting
				WHERE discussion_id = $discussion
				AND faction_id = $fackey
				AND status > 0 AND status < 3"); // TODO überlegen, wie gelöschte / zurückgezogene einheitlich unterschieden werden
				
			$sql = "SELECT duration
					FROM timelog
					WHERE discussion_id = $discussion
					AND faction_id = $fackey";
				
			$duration_share[$fackey] = $db->querySingle($sql);
			
			if ($speakers[$discussion][$fackey]>0) { $duration_average[$fackey] = $duration_share[$fackey]/$speakers[$discussion][$fackey]; } else { $duration_average[$fackey] = 0; } 
			
			$duration_full = $duration_full + $duration_share[$fackey];

			}
			
			echo '<table id="stats">';

		foreach ($factions AS $fackey => $facval) {
			
			if ( $duration_share[$fackey] < 3600 ) {
					
					$redezeit = date("i\ms\s", $duration_share[$fackey]);
					
			} else { $redezeit = (int)($duration_share[$fackey] / 3600 ) . date("\hi\ms\s", $duration_share[$fackey]); } // notwendiger Hack, damit Umstellung Sommer-Winterzeit nicht falsches Ergebnis bringt
			
			echo '<tr><td class="stats-descriptor"><b style="font-size: 16pt; background-color: grey; color: white;">' . $facval . '</b> &nbsp; <span title="Anzahl">👥 ' . $speakers[$discussion][$fackey] . '</span> &nbsp; &nbsp;<span title="Durchschnittliche Redezeit">🗣 ø' . date("i\ms\s", $duration_average[$fackey]) . '</span></td>';
			echo '<td><div style="width: ' . (300/$duration_full * $duration_share[$fackey]) . 'px; background-color: #fee; text-align: left;" title="Redezeit: ' . $redezeit . '" class="duration-bar direction1">&nbsp; ';
			
				if ($duration_share[$fackey] != 0) { echo $redezeit; }
			echo '&nbsp;</div></td>';
			echo '</tr>';
		}
	  	  
		echo '</table>';
			
			
			
				
	}
			
			
		?>
		</main>
	<?php
	
		pagefooter();
		
	?>	  
  </body>
</html><?php $db->close(); unset($db);
