<?php 

require "fct.php";

$reload = 20000; // Alle 20 Sekunden soll die Redeliste neu geladen werden	

list($event, $title, $logo, $style, $factions) = event();
list($discussion, $disc_title, $disc_status) = discussion();

// TODO: Auto-Reload-Funktion


// Redeliste der Diskussion abrufen
			
			$res = $db->query("SELECT *
				FROM waiting
				WHERE discussion_id = $discussion
				AND status < 2 
				ORDER BY created");
			while ($row = $res->fetchArray()) {
				
				if (!empty($row['organisation'])) { 
				
					$org_temp = '<br>'.$row['organisation'];
				
				} else { 
				
					$org_temp = '';
					
				}
				
				if ($row['status'] == "0" ) {
					
					$group[$row['faction_id']][] = '<p title="Wortmeldung eingereicht um '.date('H:i', $row['created']).' Uhr"><b>'.$row['person'].'</b>'.$org_temp.'</p>';
					
				} else {
					
					$speaking_started = $row["started"];
					$delay = time() - $speaking_started;
					
					$group[$row['faction_id']][] = '<p title="'.$row['person'].' spricht gerade." class="status-speaking"><b>'.$row['person'].'</b>'.$org_temp.'<br>🗣 <span id="timer">' . intval(date('i', $delay)).date(":s", $delay) . '</span></p>
					
					<script>
				var sekunden;
				sekunden = ' . $delay . '
							
			var counter = setInterval(function(){
				sekunden++;
			var s = sekunden%60;
			var minuten = Math.floor(sekunden/60);
				
				document.getElementById("timer").innerHTML = ""+minuten+":"+(s>9?"":"0")+s+"";
				 }, 1000);
			
			</script>
					
					';
					$reload = 8000; // wenn jemand spricht, soll alle 8 Sekunden die Redeliste aktualisiert werden.
				}
			}
	htmlheader();		
?>
  <body><?php
  
	  pageheader(basename(__FILE__, '.php'));
	
	  ?><main>
		  
	  <h1>Redeliste #<span style="text-transform: uppercase;"><?= $disc_title ?></span></h1>
	  <table id="redeliste">
	  <tr><?php
		foreach ($factions AS $facval) {
			echo '<th>'.$facval.'</th>';
		}
	  ?></tr>
	  <tr><?php
		foreach ($factions AS $fackey => $facval) {
		  
		  echo '<td class="redeliste-element">';
			if (array_key_exists($fackey, $group)) {
				foreach ($group[$fackey] AS $key => $val) {
					echo $val;
			}
		 } 
		 if ($disc_status == "closed") { echo "=== geschlossen ==="; }
		 
		 echo '<p>&nbsp;</p></td>';
	 }
		 ?></tr>	  	 <?php 
	  	  
	  	  // Zeige Redeanteile
	  	  durbars();
	  	  ?>
</table>Stand: <?php echo date("H:i"); ?><p>&nbsp;</p>

	  </div>
	</main>
	<?php
	
		pagefooter();
		
	?><script>
	  setTimeout(function(){
   window.location.reload(1);
}, <?= $reload ?>); // Refresh every x seconds
</script>
  </body>
</html><?php $db->close(); unset($db);
